apiVersion: v1
kind: ServiceAccount
metadata:
  name: jgroups-kubeping-service-account
  namespace: default
---
kind: ClusterRole
apiVersion: rbac.authorization.k8s.io/v1
metadata:
  name: jgroups-kubeping-pod-reader
  namespace: default
rules:
  - apiGroups: [""]
    resources: ["pods"]
    verbs: ["get", "list"]
---
kind: ClusterRoleBinding
apiVersion: rbac.authorization.k8s.io/v1
metadata:
  name: jgroups-kubeping-api-access
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: ClusterRole
  name: jgroups-kubeping-pod-reader
subjects:
  - kind: ServiceAccount
    name: jgroups-kubeping-service-account
    namespace: default
---
apiVersion: v1
kind: Pod
metadata:
  name: cleandata-pod
  labels:
    app: cleandata
spec:
  containers:
  - name: cleandata-container
    image: busybox:1.28
    command: ['sh', '-c', '> /usr/share/jboss/upstream.conf && > /usr/share/jboss/upstreamcp.conf && exit']
    volumeMounts:
    - name: config
      mountPath: /usr/share/jboss/
    securityContext:
      allowPrivilegeEscalation: false
      runAsUser: 0
    resources:
      requests:
        memory: "64Mi"
        cpu: "250m"
      limits:
        memory: "128Mi"
        cpu: "500m"
  restartPolicy: Never
  volumes:
  - name: config
    hostPath:
      path: /cloud/kubernetes/wildfly/config
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: wildfly
spec:
  selector:
    matchLabels:
      app: wildfly
  replicas: 2
  template: 
    metadata:
      labels:
        app: wildfly
    spec:
      serviceAccountName: jgroups-kubeping-service-account
      containers:
        - name: wildfly
          image: jboss/wildfly:latest
          resources:
           requests:
            memory: "500Mi"
            cpu: "250m"
           limits:
            memory: "700Mi"
            cpu: "500m"
          imagePullPolicy: Always
          ports:
            - containerPort: 8080
            - containerPort: 7600
            - containerPort: 8888
            - containerPort: 9990
          env:
            - name: pod_ip
              value: "0.0.0.0"
            - name: kubernetes_labels
              value: app=wildfly
            - name: MY_POD_NAME
              valueFrom:
                fieldRef:
                  fieldPath: metadata.name
            - name: MY_POD_NAMESPACE
              valueFrom:
                fieldRef:
                  fieldPath: metadata.namespace
            - name: MY_POD_IP
              valueFrom:
                fieldRef:
                  fieldPath: status.podIP
          command: ["/bin/sh"]
          args: [ "-c", "/usr/share/jboss/nginx-upstream.sh add $MY_POD_IP:8080 $MY_POD_IP:9990 && /opt/jboss/wildfly/bin/add-user.sh admin jboss --silent && /opt/jboss/wildfly/bin/jboss-cli.sh --file=/usr/share/jboss/config-server.cli && cp -R /usr/share/jboss/kubeping $JBOSS_HOME/modules/system/layers/base/org/jgroups/kubernetes && rm -rf /opt/jboss/wildfly/standalone/configuration/standalone_xml_history/* && /opt/jboss/wildfly/bin/standalone.sh -c standalone-full-ha.xml -b $MY_POD_IP -bprivate $MY_POD_IP -bmanagement $MY_POD_IP -Djboss.node.name=$HOSTNAME -Djboss.txn.uniqueid=$MY_POD_IP -Djboss.messaging.cluster.password=appsr && sleep infinity"]
          volumeMounts:
          - name: config
            mountPath: /usr/share/jboss/
          - name: webapps
            mountPath: /opt/jboss/wildfly/standalone/deployments
          securityContext:
            allowPrivilegeEscalation: false
            runAsUser: 0
      volumes:
      - name: config
        hostPath:
          path: /cloud/kubernetes/wildfly/config
      - name: webapps
        hostPath:
          path: /cloud/kubernetes/wildfly/config/webapps
---
apiVersion: v1
kind: Service
metadata:
  labels:
    app: nginx
  name: nginx-service
  namespace: default
spec:
  ports:
  - nodePort: 88
    port: 88
    protocol: TCP
    targetPort: 80
  selector:
    app: nginx
  type: NodePort
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: nginx-deployment
spec:
  selector:
    matchLabels:
      app: nginx
  replicas: 1
  template:
    metadata:
      labels:
        app: nginx
    spec:
      serviceAccountName: jgroups-kubeping-service-account
      containers:
      - name: nginx
        image: nginx:latest
        ports:
        - containerPort: 80
        volumeMounts:
          - name: config
            mountPath: /etc/nginx/conf.d/
        securityContext:
            allowPrivilegeEscalation: false
            runAsUser: 0
        resources:
         requests:
          memory: "250Mi"
          cpu: "250m"
         limits:
          memory: "400Mi"
          cpu: "500m"
      volumes:
      - name: config
        hostPath:
          path: /cloud/kubernetes/wildfly/config